%%%-------------------------------------------------------------------
%% @doc test07a public API
%% @end
%%%-------------------------------------------------------------------

-module(test07a_app).

-behaviour(application).

%% Application callbacks
-export([start/2, stop/1]).

%%====================================================================
%% API
%%====================================================================

%~ start(_StartType, _StartArgs) ->
%~     test07a_sup:start_link().

start(_Type, _Args) ->
    {ok, DataFileName} = application:get_env(test07a, data_file_name),
    dets:open_file(dets_data_file, [{file, DataFileName}, {type, set}]),
    Dispatch = cowboy_router:compile([
        {'_',
         [
          {"/docs/get/:doc_id", test07a_handler, [{op, get}]},
          {"/docs/list", test07a_handler, [{op, list}]},
          {"/docs/create", test07a_handler, [{op, create}]},
          {"/docs/update/:doc_id", test07a_handler, [{op, update}]},
          {"/docs/delete/:doc_id", test07a_handler, [{op, delete}]},
          {"/docs/help", test07a_handler, [{op, help}]},
          {"/docs", test07a_handler, [{op, help}]}
         ]}
                                     ]),
    {ok, _} = cowboy:start_clear(test07a_http_listener, 100,
                                 [{port, 8002}],
                                 #{env => #{dispatch => Dispatch}}
                                ),
    db_sup:start_link(),
    test07a_sup:start_link().

%%--------------------------------------------------------------------
stop(_State) ->
    ok.

%%====================================================================
%% Internal functions
%%====================================================================
